
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif_rgb.h"
#include "sif.h"
#include "sif_rgb.h"

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,BPS,shift,y,x;
	Cell	**R,**G,**B;
	char	*desc;

	if (argc!=3) {
	    (void)fputs("usage : trgb TIFF RGB_TIFF\n",stderr); exit(1);
	}
	ReadImageFile_RGB(argv[1],&Nx,&Ny,&BPS,&R,&G,&B,&desc);

	if (BPS>8) {
	    shift=BPS-8;
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) {
		R[y][x]>>=shift; G[y][x]>>=shift; B[y][x]>>=shift;
	    }
	    BPS=8;
	}
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    if (R[y][x]!=G[y][x] || R[y][x]!=B[y][x]) goto Break;

Break:;
	if (x==Nx && y==Ny)
	    StoreImageFile(argv[2],Nx,Ny,BPS,R,desc);
	else
	    StoreImageFile_RGB(argv[2],Nx,Ny,BPS,R,G,B,desc);

	return 0;
}
